# Copyright (c) 2000-2009, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define gcj_support %{?_with_gcj_support:1}%{!?_with_gcj_support:%{?_without_gcj_support:0}%{!?_without_gcj_support:%{?_gcj_support:%{_gcj_support}}%{!?_gcj_support:0}}}

%define section free

Name:           jibx
Version:        1.1.6a
Release:        1%{?dist}
Epoch:          0
Summary:        JiBX is a framework for binding XML data to Java objects.
License:        Public Domain
Url:            http://jibx.sourceforge.net/
Group:          Text Processing/Markup/XML
Source0:        %{name}_1_1_6a.zip
Source1:        http://repo1.maven.org/maven2/org/jibx/jibx-bind/1.1.6a/jibx-bind-1.1.6a.pom
Source2:        http://repo1.maven.org/maven2/org/jibx/jibx-extras/1.1.6a/jibx-extras-1.1.6a.pom
Source3:        http://repo1.maven.org/maven2/org/jibx/jibx-run/1.1.6a/jibx-run-1.1.6a.pom

BuildRequires:  jpackage-utils >= 0:1.7.3
BuildRequires:  java-devel >= 0:1.5.0
BuildRequires:  ant >= 0:1.6.5
BuildRequires:  ant-junit
BuildRequires:  junit
BuildRequires:  asm2 >= 2.1
BuildRequires:  bcel
BuildRequires:  dom4j
BuildRequires:  jdom
BuildRequires:  log4j
BuildRequires:  qdox
BuildRequires:  stax_1_0_api
BuildRequires:  wstx
BuildRequires:  xpp3
%if %{gcj_support}
BuildRequires:    java-gcj-compat-devel
Requires(post):   java-gcj-compat
Requires(postun): java-gcj-compat
%endif

Requires:       java >= 0:1.5.0
Requires:       asm2 >= 2.1
Requires:       bcel
Requires:       dom4j
Requires:       jdom
Requires:       log4j
Requires:       stax_1_0_api
Requires:       qdox
Requires:       wstx
Requires:       xpp3
Requires(post):    jpackage-utils >= 0:1.7.3
Requires(postun):  jpackage-utils >= 0:1.7.3

%if ! %{gcj_support}
BuildArch:      noarch
%endif

BuildRoot: %{_tmppath}/%{name}-%{version}-buildroot

%description
JiBX is a framework for binding XML data to Java objects. It lets you
work with data from XML documents using your own class structures.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%prep
%setup -q -n %{name}
for j in $(find lib -name "*.jar"); do
    mv $j $j.no
done


%build

# dom4j and jdom are optional. If povided, jibx-extras is built with
# support for those models

build-jar-repository -p lib \
asm2/asm2 \
asm2/asm2-commons \
bcel \
dom4j \
jdom \
junit \
log4j \
qdox \
stax_1_0_api \
wstx/wstx-asl \
xpp3

pushd build/
sed -i -e s:stax-api.jar:stax_1_0_api.jar:g build.xml
sed -i -e s:wstx-asl.jar:wstx-asl.jar:g build.xml
ant current devdoc testing

%install
rm -rf $RPM_BUILD_ROOT

install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/%{name}
for sub_component in bind extras run; do
install -m 644 lib/jibx-${sub_component}.jar \
     $RPM_BUILD_ROOT%{_javadir}/%{name}/${sub_component}-%{version}.jar
done

%add_to_maven_depmap org.jibx %{name}-bind %{version} JPP/%{name} bind
%add_to_maven_depmap jibx %{name}-bind %{version} JPP/%{name} bind
%add_to_maven_depmap org.jibx %{name}-extras %{version} JPP/%{name} extras
%add_to_maven_depmap jibx %{name}-extras %{version} JPP/%{name} extras
%add_to_maven_depmap org.jibx %{name}-run %{version} JPP/%{name} run
%add_to_maven_depmap jibx %{name}-run %{version} JPP/%{name} run

# create unprefixed and unversioned symlinks
(cd $RPM_BUILD_ROOT%{_javadir}/%{name}
for jar in *-%{version}*; do ln -sf ${jar} ${jar/-%{version}/}; done
)

# poms
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
install -pm 644 %{SOURCE1} \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-bind.pom
install -pm 644 %{SOURCE2} \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-extras.pom
install -pm 644 %{SOURCE3} \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-extras.pom


install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr build/docs/dev/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name}

%if %{gcj_support}
%{_bindir}/aot-compile-rpm
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap
%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%postun
%update_maven_depmap
%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%files
%defattr(0644,root,root,0755)
%dir %{_javadir}/%{name}
%{_javadir}/%{name}/*.jar
%{_datadir}/maven2/poms/*
%{_mavendepmapfragdir}/*
%if %{gcj_support}
%dir %attr(-,root,root) %{_libdir}/gcj/%{name}
%attr(-,root,root) %{_libdir}/gcj/%{name}/*-%{version}.jar.*
%endif

%files javadoc
%defattr(0644,root,root,0755)
%doc %{_javadocdir}/%{name}-%{version}
%doc %{_javadocdir}/%{name}

%changelog
* Tue Mar 24 2009 Ralph Apel <r.apel at r-apel.de> 0:1.1.6a-1.jpp5
- Upgrade to 1.1.6a

* Wed May 30 2007 Ralph Apel <r.apel at r-apel.de> 0:1.1.5-1jpp
- Upgrade to 1.1.5
- Make Vendor, Distribution based on macro
- Add gcj_support option
- Install depmap frags, poms

* Wed May 24 2006 Deepak Bhole <dbhole@redhat.com> 0:1.1-0.b3.1jpp
- Initial build
